searchNodes=[{"doc":"Rate limiting Plug module based on Redis Lua scripting. Architecture PlugLimit is a Plug behaviour module implementation using Redis Lua scripting to provide rate limiting functionality. Module plugs should implement two callback functions: Plug.init/1 and Plug.call/2 . PlugLimit init/1 function is responsible for building plug configuration, please refer to the Configuration section below for details. PlugLimit call/2 function has following responsibilities: Establish if given request should be allowed or denied in accordance with selected rate limiting strategy. Determine values of the rate limiting http headers. Set rate limiting http headers for the response. Halt request processing pipeline if rate limit was exceeded and send response with appropriate status code, usually 429 - Too Many Requests . Tasks 1 and 2 are performed by evaluation of the Redis Lua script implementing rate limiting algorithm. Tasks 3 and 4 are executed by built-in put_response/4 function or user provided equivalent callback function leveraging Redis Lua script evaluation results. PlugLimit Redis Lua scripts are loaded to the Redis scripts cache on the first Plug.call/2 callback invocation by using Redis SCRIPT LOAD command. Generated by SCRIPT LOAD SHA1 script hash is cached locally as a :persistent_term key. Lua script SHA1 hash is later retrieved from :persistent_term local cache and used with Redis EVALSHA command on subsequent rate-limiter Lua script evaluations. Implemented SHA1 Lua script caching mechanism is resilient to Redis script cache resets by Redis instance reboots or Redis SCRIPT FLUSH command use. Redis Lua script evaluation is an atomic operation resilient to the race conditions in distributed environments. In normal circumstances latency introduced by Redis EVALSHA command should be close to a single Redis request/response round trip time, usually less than ~1 ms. Redis Lua script execution blocks single-threaded Redis server, so it is advised to use a separate standalone Redis instance for PlugLimit rate-limiters, especially when using custom untested Lua script implementations. Data stored by Redis rate-limiters in most cases can be considered as strongly interim so using highly available Redis Sentinel instances for rate-limiters data might be unnecessary. For high traffic volume cases, sharding can be easily achieved by distributing independent Phoenix router pipelines or scopes rate-limiters between dedicated Redis instances. Usage PlugLimit in most basic use case requires configuration of a function which will execute Redis commands: # config/config.exs config :plug_limit , enabled? : true , cmd : { MyApp.Redis , :command , [ ] } When working with Phoenix Framework PlugLimit plug call can be placed at the endpoint, router or controller depending on requirements. Example of minimal PlugLimit call used in :high_cost_pipeline router pipeline: #lib/my_app_web/router.ex pipeline :high_cost_pipeline do plug ( PlugLimit , opts : [ 10 , 60 ] , key : { MyApp.RateLimiter , :user_id_key , [ :high_cost_pipeline ] } ) # remaining pipeline plugs... end Example above will evaluate request rate-limiting parameters using built-in default Lua script implementing fixed window algorithm with rate limiter algorithm options given in the :opts list. First list element specifies request limit, set to 10 here, second item specifies limiting time window length in seconds, set to 60. Redis rate-limiter bucket name will be evaluated with function defined by the :key MFA tuple. Example Redis key bucket name function result for user_id=12345 : {:ok, [&quot;high_cost_pipeline_limiter:12345&quot;]} . Example PlugLimit configuration for built-in token bucket rate-limiter: #lib/my_app_web/router.ex pipeline :high_cost_pipeline do plug ( PlugLimit , limiter : :token_bucket , opts : [ 20 , 600 , 5 ] , key : { MyApp.RateLimiter , :user_id_key , [ &quot;high_cost_pipeline&quot; ] } ) # remaining pipeline plugs... end Configuration options details are described in the Configuration section below. Instead of using generic PlugLimit module you can use provided convenience wrappers: PlugLimit.FixedWindow or PlugLimit.TokenBucket . Built-in rate-limiting algorithms are described in the &quot;Redis Lua script rate limiters&quot; LIMITERS.md file. Unit testing for user applications using PlugLimit library is described in &quot;Unit testing&quot; TESTING.md file. Configuration PlugLimit configuration is built from following sources: global :plug_limit configuration parameters from application configuration file, usually config/*.exs , parameters overwriting global configuration passed as arguments to the PlugLimit plug call in the application router or controller, hard-coded default values. PlugLimit is using a concept of rate-limiters to organize individual limiters configurations. Rate-limiters configurations are declared in application configuration file using :limiters key. Each rate-limiter must be associated with a valid Lua script. Lua scripts are configured with :luascripts key. Full example configuration defining :custom_limiter limiter using :custom_bucket Lua script: # config/config.exs config :plug_limit , limiters : [ custom_limiter : %{ cmd : { MyApp.Redis , :command , [ &quot;redis://10.10.10.2:6379/&quot; ] } , key : { MyApp.RateLimiter , :user_id_key , [ ] } , log_level : :error , luascript : :custom_bucket , response : { MyApp.RateLimiter , :respond , [ ] } } ] , luascripts : [ custom_bucket : %{ script : { File , :read , [ &quot;./lua/custom_bucket.lua&quot; ] } , headers : [ &quot;x-ratelimit-limit&quot; , &quot;x-ratelimit-reset&quot; , &quot;x-ratelimit-remaining&quot; , &quot;x-acme-custom-header&quot; ] } ] Above defined :custom_limiter should be referred as follows: plug ( PlugLimit , limiter : :custom_limiter , opts : [ 20 , 600 , 5 ] ) Application configuration options Primary part of PlugLimit configuration is located in the application configuration file, usually config/config.exs , under :plug_limit key. Some of the options defined in application configuration can be overwritten with plug(PlugLimit, [options...]) call. Available configuration options: :enabled? - when set to Boolean false or string &quot;false&quot; PlugLimit is disabled and plug(PlugLimit, opts: [...]) call immediately returns unmodified conn struct. To enable PlugLimit , :enabled? key must be set to Boolean true or string &quot;true&quot; . Default: false . :cmd - MFA tuple pointing at the user defined two arity function executing Redis commands. As a first argument function will receive a Redis command as a list, for example: [&quot;SET&quot;, &quot;mykey&quot;, &quot;foo&quot;] . As a second parameter, static argument defined in the MFA tuple will be passed. Redis command function should return {:ok, redis_response} on success and {:error, reason} on error. When using Redix library as a client, :cmd command should be a Redix.command/3 wrapper. When using eredis library, wrapper for the :eredis.q/2,3 should be implemented. Redis command function defined here will be used as a default function for limiters that do not have their own :cmd specified. Optional if each limiter has its own :cmd defined, required otherwise. :log_level - specifies log level for rate-limiters that do not set their own :log_level . Only library errors are logged - with put_response/4 function. Boolean value false disables logging. Please refer to the Logger documentation for valid log levels. Default: :error . :response - MFA tuple pointing at the user defined 4 arity function providing request response depending on rate-limiter Lua script evaluation results. Please refer to the built-in response function put_response/4 description for details. Can be overwritten for individual limiters. Default: put_response/4 . :limiters - keyword list with user provided rate-limiters. See below for details. Optional. :luascripts - keyword list defining Lua scripts for rate-limiters defined with :limiters . See below for details. Optional. PlugLimit :enabled? option is the only option evaluated at run-time with Plug.call/2 , so function like System.get_env/2 can be used here. All other configuration options are initialized with Plug.init/1 , which usually takes place at compile time for production or release environments and run-time for testing and development. In a production environment, PlugLimit :enabled might be controlled using environmental variable, for example: # config/config.exs config :plug_limit , cmd : { MyApp.Redis , :command , [ ] } # config/releases.exs config :plug_limit , enabled? : System . get_env ( &quot;PLUG_LIMIT_ENABLED&quot; , &quot;false&quot; ) # config/dev.exs config :plug_limit , enabled? : true # config/test.exs config :plug_limit , enabled? : true Custom user rate-limiters are configured as a :limiters keyword list. Rate-limiters are declared as maps with following keys: :cmd - overwrites :cmd global key for a given rate-limiter. Optional. :key - MFA tuple pointing at the user defined two arity function providing Redis keys names that will be passed later to the Redis Lua script. Function receives request Plug.Conn.t() struct as a first argument and static argument from the MFA tuple as a second argument. Function should return {:ok, [key :: String.t()]} when successful and {:error, reason} on error. Function should return especially name of the key that Redis Lua script will use to create a unique bucket for a given rate-limiter and requests group. Please refer to &quot;Redis Lua script rate limiters&quot; LIMITERS.md file for further discussion. Example :key function implementation: def user_key ( % Plug.Conn { assigns : %{ user_id : user_id } } , prefix ) , do : { :ok , [ to_string ( prefix ) &lt;&gt; &quot;:&quot; &lt;&gt; to_string ( user_id ) ] } def user_key ( _conn , _prefix ) , do : { :error , &quot;Missing user_id&quot; } Redis keys names should follow Redis keys naming conventions . :key value can be overwritten in a plug call configuration. Optional if :key is specified for each PlugLimit plug call, required otherwise. :log_level - overwrites global :log_level for a given rate-limiter. Optional. :luascript - atom defining Lua script for a given rate-limiter. Lua scripts are defined with :luascripts keyword list, see below for details. Required. :response - overwrites global :response for a given rate-limiter. Optional. PlugLimit provides two built-in rate-limiters: :fixed_window and :token_bucket , please refer to &quot;Redis Lua script rate limiters&quot; LIMITERS.md file for details. Each rate-limiter is associated with Redis Lua script checking if given request should be allowed or denied and evaluating rate limiting http headers. Redis Lua scripts are configured as :luascripts keyword list. Each script is declared as a map with following keys: :script - MFA tuple pointing at one arity function returning {:ok, limiter_script :: String.t()} on success and {:error, reason} on error. Function receives as an argument static argument from the MFA tuple. Example implementations: def get_lua_script_by_path ( path ) , do : File . read ( path ) def my_lua_script ( _arg ) , do : { :ok , &quot;-- Lua script body&quot; } Required. :headers - list of rate limiting headers keys to be used with headers values returned by given Redis Lua script to build request response http headers. Example headers list: headers : [ &quot;x-ratelimit-limit&quot; , &quot;x-ratelimit-reset&quot; , &quot;x-ratelimit-remaining&quot; ] Please refer to &quot;Redis Lua script rate limiters&quot; LIMITERS.md file for more detailed discussion on rate limiting headers. Required. Plug call configuration options :key - MFA tuple, overwrites value given in limiter's application configuration. Required if not provided in the limiter configuration. :limiter - atom selecting rate limiter. List of built-in limiters is provided in LIMITERS.md file. Default: :fixed_window . :opts - list with rate limiting options like requests limit, time window length or burst rate. List is passed as an argument to the Redis Lua script, see LIMITERS.md for built-in limiters options. Required.","ref":"PlugLimit.html","title":"PlugLimit","type":"module"},{"doc":"Puts new rate limiting http response headers in the connection and halts the Plug pipeline if rate limit was exceeded. put_response/4 is a default PlugLimit function preparing an http response accordingly with Redis Lua script evaluation results. Custom response function can be selected by setting :response global or given limiter configuration keys. Function accepts following arguments: Plug.Conn.t() connection. Rate-limiter configuration as a PlugLimit.t() struct. Redis Lua script evaluation result as a PlugLimit.eval_result() type. Static argument given in the :response MFA tuple. Function returns Plug.Conn.t() struct with rate limiting headers. If rate limit is exceeded function halts Plug pipeline and sends response with 429 status code and plain-text body &quot;Too Many Requests&quot; . If Redis Lua script evaluation or any other rate-limiting processing function fails, put_response/4 function will log resulting error with Logger level set by :log_level configuration setting and return unmodified connection struct. Custom response functions and custom Redis Lua scripts are described in more details in &quot;Redis Lua script rate limiters&quot; LIMITERS.md file.","ref":"PlugLimit.html#put_response/4","title":"PlugLimit.put_response/4","type":"function"},{"doc":"","ref":"PlugLimit.html#t:eval_result/0","title":"PlugLimit.eval_result/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:limiter/0","title":"PlugLimit.limiter/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:limiters/0","title":"PlugLimit.limiters/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:log_level/0","title":"PlugLimit.log_level/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:luascript/0","title":"PlugLimit.luascript/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:luascripts/0","title":"PlugLimit.luascripts/0","type":"type"},{"doc":"","ref":"PlugLimit.html#t:t/0","title":"PlugLimit.t/0","type":"type"},{"doc":"Fixed window rate limiter Plug. PlugLimit.FixedWindow is a convenience wrapper build on top of a PlugLimit plug. Module provides syntactic sugar for fixed window algorithm specific options. Usage Example usage: #lib/my_app_web/controllers/page_controller.ex plug PlugLimit.FixedWindow , [ limit : 10 , ttl : 60 , key : { MyApp.RateLimiter , :my_key , &quot;page_controller:fixed_window&quot; } ] when action in [ :create ] Action :create in PageController will be protected by fixed window rate-limiter. Users will be able to issue up to 10 requests in 60 seconds time window. Example code above corresponds to the following direct PlugLimit usage: #lib/my_app_web/controllers/page_controller.ex plug PlugLimit , [ limiter : :fixed_window , opts : [ 10 , 60 ] , key : { MyApp.RateLimiter , :my_key , &quot;page_controller:fixed_window&quot; } ] when action in [ :create ] Configuration Configuration options: :limit - requests limit. Required. :ttl - rate-limiter time to live (time-window length) defined as number of seconds. Required. :key - same as PlugLimit :key configuration option. Required.","ref":"PlugLimit.FixedWindow.html","title":"PlugLimit.FixedWindow","type":"module"},{"doc":"Conveniences for testing endpoints protected with PlugLimit rate limiters. Unit testing endpoints protected with rate limiters might provide unexpected results because after exceeding requests limit during consecutive tests given endpoint will respond with 429 status code. PlugLimit.Test can help to avoid unexpected 429 responses by adding following code to your test cases: use PlugLimit.Test , redis_flushdb? : true Using this module with :redis_flushdb? set to true will flush Redis database with redis_flushdb/1 function executed inside ExUnit.Callbacks.setup/1 . Required by redis_flushdb/1 Redis command function is taken from :plug_limit :cmd key defined for testing environment, for example: # config/test.exs config :plug_limit , cmd : { MyApp.Redis , :command , [ ] } Please refer to PlugLimit module documentation for detailed :cmd setting description. PlugLimit.Test has one configuration setting :redis_flushdb? , set to false by default. When using :redis_flushdb? you might consider setting separate Redis database (e.g.: redis://localhost:6379/15 ) for PlugLimit to avoid interference with other parts of your application during testing. Alternatively to :redis_flushdb? you can use redis_del_keys/2 .","ref":"PlugLimit.Test.html","title":"PlugLimit.Test","type":"module"},{"doc":"Gets x-ratelimit-remaining header from conn and parses it to integer. Returns x-ratelimit-remaining header as an integer or string message if invalid or missing header. Example: test &quot;x-ratelimit-remaining is correct&quot; , %{ conn : conn } do conn = get ( conn , &quot;/&quot; ) assert PlugLimit.Test . get_remaining ( conn ) == 60 end iex&gt; PlugLimit.Test . get_remaining ( conn_invalid_header ) &quot;Invalid, non-standard or missing x-ratelimit-remaining header.&quot;","ref":"PlugLimit.Test.html#get_remaining/1","title":"PlugLimit.Test.get_remaining/1","type":"function"},{"doc":"Same as get_remaining/1 but for x-ratelimit-reset header.","ref":"PlugLimit.Test.html#get_reset/1","title":"PlugLimit.Test.get_reset/1","type":"function"},{"doc":"Checks for IETF recommended x-ratelimit-* http response headers in conn . Checks if basic rate limiting http response headers complying with &quot;RateLimit Fields for HTTP&quot; IETF specification are added to Plug.Conn.t() . Required rate limiting http response headers: x-ratelimit-limit , x-ratelimit-remaining , x-ratelimit-reset . Returns true if above headers are present and false otherwise. Example: test &quot;it is protected by rate limiter&quot; , %{ conn : conn } do conn = get ( conn , &quot;/&quot; ) assert PlugLimit.Test . headers_exist? ( conn ) end","ref":"PlugLimit.Test.html#headers_exist?/1","title":"PlugLimit.Test.headers_exist?/1","type":"function"},{"doc":"Deletes all keys with the names matching pattern given by key from the Redis DB selected with {m, f, a} Redis command function. {m, f, a} usually should be consistent with a value given in :plug_limit :cmd configuration key. Returns :ok on success or any() on error. Function should not be used to delete large numbers of Redis keys. Example: setup do :ok = PlugLimit.Test . redis_del_keys ( { MyApp.Redis , :command , [ ] } , &quot;my_key:*&quot; ) end","ref":"PlugLimit.Test.html#redis_del_keys/2","title":"PlugLimit.Test.redis_del_keys/2","type":"function"},{"doc":"Deletes all keys from the Redis DB selected with {m, f, a} Redis command function. {m, f, a} usually should be consistent with a value given in :plug_limit :cmd configuration key. Returns :ok on success or any() on error. Redis command which is used to delete keys: FLUSHDB SYNC . Example: iex&gt; PlugLimit.Test . redis_flushdb ( { MyApp.Redis , :command , [ ] } ) :ok","ref":"PlugLimit.Test.html#redis_flushdb/1","title":"PlugLimit.Test.redis_flushdb/1","type":"function"},{"doc":"Token bucket rate limiter Plug. PlugLimit.TokenBucket is a convenience wrapper build on top of a PlugLimit plug. Module provides syntactic sugar for token bucket algorithm specific options. Usage Example usage: #lib/my_app_web/controllers/page_controller.ex plug PlugLimit.TokenBucket , [ burst : 3 , limit : 6 , ttl : 60 , key : { MyApp.RateLimiter , :my_key , &quot;page_controller:token_bucket&quot; } ] when action in [ :create ] Action :create in PageController will be protected by token bucket rate-limiter. Users will be able to issue up to 6 requests in 60 seconds time window with initial burst rate 3 requests. Example code above corresponds to the following direct PlugLimit usage: #lib/my_app_web/controllers/page_controller.ex plug PlugLimit , [ limiter : :token_bucket , opts : [ 6 , 60 , 3 ] , key : { MyApp.RateLimiter , :my_key , &quot;page_controller:token_bucket&quot; } ] when action in [ :create ] Configuration Configuration options: :burst - token bucket initial burst rate. Required. :limit - requests limit. Required. :ttl - rate-limiter time to live (time-window length) defined as number of seconds. Required. :key - same as PlugLimit :key configuration option. Required.","ref":"PlugLimit.TokenBucket.html","title":"PlugLimit.TokenBucket","type":"module"},{"doc":"Rate limiting Plug module based on Redis Lua scripting.","ref":"readme.html","title":"PlugLimit","type":"extras"},{"doc":"PlugLimit is using Redis Lua scripting to provide rate-limiting functionality for web applications based on a Plug library. PlugLimit has a modular architecture: users can use their own Redis Lua scripts implementing custom rate limiting algorithms. Salient Redis Lua scripting feature is a race conditions resiliency which makes this library a recommended solution for distributed systems (e.g.: Phoenix servers behind round robin load balancer). PlugLimit provides two built-in rate limiters: PlugLimit.FixedWindow and PlugLimit.TokenBucket .","ref":"readme.html#summary","title":"PlugLimit - Summary","type":"extras"},{"doc":"Add PlugLimit library to your application dependencies: def deps do [ { :plug_limit , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"PlugLimit - Installation","type":"extras"},{"doc":"PlugLimit is Redis client agnostic. In a first step you must define Elixir function executing Redis commands, depending on Redis client of your choice: # config/config.exs config :plug_limit , enabled? : true , cmd : { MyApp.Redis , :command , [ ] } MyApp.Redis.command/2 function must accept Redis command as a first argument and static MFA tuple arg as a second. In most cases :cmd function will be a Redix.command/3 or :eredis.q/2,3 wrapper. Example naive Redix driver wrapper: #lib/my_app/redis.ex def command ( command , opts \\\\ [ timeout : 500 ] ) do { :ok , pid } = Redix . start_link ( ) Redix . command ( pid , command , opts ) :ok = Redix . stop ( pid ) end PlugLimit is tested with both Redix and eredis Redis clients. Phoenix Framework endpoint can be protected with fixed window rate-limiter by placing a PlugLimit.FixedWindow plug call in the request processing pipeline: #lib/my_app_web/router.ex pipeline :high_cost_pipeline do plug ( PlugLimit.FixedWindow , limit : 10 , ttl : 60 , key : { MyApp.RateLimiter , :user_key , [ :high_cost_pipeline ] } ) # remaining pipeline plugs... end Rate limits for :high_cost_pipeline pipeline will be evaluated with Redis Lua script fixed window algorithm. Client identified with :key will be allowed to issue 10 requests in 60 seconds time window. MFA tuple defined with :key option specifies user function which should provide Redis key used to uniquely identify given rate-limiter bucket. Redis rate-limiter key name should be derived from Plug.Conn.t() connection struct parameters. Example function to create Redis key name for rate-limiter throttling requests for a given user identified by a connection assigned :user_id : #lib/my_app/rate_limiter.ex def user_key ( % Plug.Conn { assigns : %{ user_id : user_id } } , prefix ) , do : { :ok , [ &quot; \#{ prefix } : \#{ user_id } &quot; ] } Please refer to PlugLimit module documentation for detailed library configuration description and &quot;Redis Lua script rate limiters&quot; in LIMITERS.md file for Redis Lua scripts implementation guidelines.","ref":"readme.html#usage","title":"PlugLimit - Usage","type":"extras"},{"doc":"[ ] Add leaky bucket rate limiting algorithm implementation.","ref":"readme.html#todo","title":"PlugLimit - TODO","type":"extras"},{"doc":"PlugLimit is using Redis Lua scripts to perform following tasks: Establish if given request should be allowed or denied. Determine rate limiting http headers values. Redis Lua scripts must internally manage request counters as Redis keys, sets or hashes to provide rate limiting functionality. All tasks listed above must be executed as a single check-and-set Redis Lua script operation.","ref":"limiters.html","title":"Redis Lua script rate limiters","type":"extras"},{"doc":"Redis Lua script input is a concatenation of two PlugLimit configuration keys values: :key MFA tuple derivative and :opts . Please refer to PlugLimit module documentation for detailed configuration description. Redis Lua scripts should accept following input parameters sourced from Elixir code: List of all Redis keys used by a script. Keys are generated by user function specified with :key MFA tuple. Keys list should especially include an unique name used by script to create Redis key/set/hash counting requests. List of rate limiting algorithm options set with :opts configuration key. Example Redis Lua script input for built-in :fixed_window limiter (Elixir syntax): [ &quot;my_protected_pipeline_name:12345&quot; , 10 , 60 ] Fixed window Lua script will use the first list value for the Redis key name - used to store given request group requests counter. Remaining list elements correspond to the fixed window rate limiting algorithm options :opts : 10 requests are allowed in 60 seconds time window. Number and order of :opts parameters depends on the individual Redis Lua script implementation.","ref":"limiters.html#input","title":"Redis Lua script rate limiters - Input","type":"extras"},{"doc":"Redis Lua script output is passed as an argument to the PlugLimit.put_response/4 function or user provided equivalent response function as a third argument. Redis Lua script output format might differ from specification given below if user is using customized response function implementation. Redis Lua script compatible with PlugLimit.put_response/4 function should return a list with following items: String &quot;allow&quot; | &quot;deny&quot; specifying if given request should be allowed or denied. List of http headers values consistent with a list of http headers keys defined with :headers configuration key. Other optional output parameters. Optional script output is ignored by built-in PlugLimit.put_response/4 . Rate limiting http response headers should comply with &quot;RateLimit Fields for HTTP&quot; IETF specification. Example Redis Lua script output for the built-in :fixed_window limiter (Elixir syntax): [ &quot;allow&quot; , [ &quot;10&quot; , &quot;60&quot; , &quot;9&quot; ] ] Output above means that request should be allowed and following http headers should be set: &quot;x-ratelimit-limit&quot; =&gt; &quot;10&quot; &quot;x-ratelimit-reset&quot; =&gt; &quot;60&quot; &quot;x-ratelimit-remaining&quot; =&gt; &quot;9&quot; Custom Redis Lua scripts can overwrite individual http headers keys if required, for example: [ &quot;allow&quot; , [ &quot;10&quot; , [ &quot;x-acme-header&quot; , &quot;60&quot; ] , &quot;9&quot; ] ] Output above will translate to the following http headers when using PlugLimit.put_response/4 with :headers set as for :fixed_window : &quot;x-ratelimit-limit&quot; =&gt; &quot;10&quot; &quot;x-acme-header&quot; =&gt; &quot;60&quot; &quot;x-ratelimit-remaining&quot; =&gt; &quot;9&quot;","ref":"limiters.html#output","title":"Redis Lua script rate limiters - Output","type":"extras"},{"doc":"Algorithm is selected by setting limiter: :fixed_window in a plug call. Fixed window algorithm assumes that timeline is divided into windows of a fixed length, for example 60 seconds. Time window is associated with requests counter set initially to the requests limit value, for example limit 10 requests in 60 seconds time window. Request counter is decreased by one on each request. If current request counter value is greater than zero request is allowed, otherwise rate limit was exceeded and request is denied. Requests counter is reset to original state after time window seconds number. Pros: Simplicity which translates into high performance. Simple key =&gt; value is sufficient to store rate-limiter state, which means minimal Redis memory requirements. Cons: Requests limit might be consumed by potential attacker in a single burst, which might put increased pressure on the server resources. Inputs: function set by :key value should return list with a single string. String will be used as a Redis key name. :opts should provide list with two integers: 1. requests limit and 2. time window length in seconds. Output list: string &quot;allow&quot; | &quot;deny&quot; , list of three http headers values in a following order: [&quot;x-ratelimit-limit&quot;, &quot;x-ratelimit-reset&quot;, &quot;x-ratelimit-remaining&quot;]","ref":"limiters.html#fixed-window","title":"Redis Lua script rate limiters - Fixed window","type":"extras"},{"doc":"Algorithm is selected by setting limiter: :token_bucket in a plug call. Token bucket algorithm is based on an analogy of a fixed capacity bucket filled with tokens. Initial amount of tokens in the bucket is equal to the burst value. On each request one token is removed from the bucket. If bucket is empty request is denied. Tokens in the bucket are added with a constant rate calculated in PlugLimit implementation as: (limit - burst) / time_window_length . For example: if time window length is set to 60 seconds, limit is equal 15 requests and burst equal to 3 requests, tokens will be added at the rate 0.2 tokens per second, or in other words new token will be added every 5 seconds. Bucket is reset to original state every time window length seconds. Pros: Protected endpoint traffic is smoother than in case of fixed window algorithm, which translates into smoother server load. Cons: More complex implementation than fixed window, translating into more Redis CPU resources usage. Limiter state is stored as a Redis hash with three numeric values: remaining requests count, tokens count and timestamp. It means higher Redis memory requirements than for a fixed window algorithm. Inputs: function set by :key value should return list with a single string. String will be used as a Redis hash name. :opts should provide list with three integers in a following order: requests limit, 2. time window length in seconds and 3. allowed initial requests burst count. Output list: string &quot;allow&quot; | &quot;deny&quot; , list of three or four http headers values depending on a bucket tokens count. If limiter's bucket is filled with tokens three http headers values are returned: [&quot;x-ratelimit-limit&quot;, &quot;x-ratelimit-reset&quot;, &quot;x-ratelimit-remaining&quot;]. If bucket is empty, additional header &quot;retry-after&quot; is returned. &quot;retry-after&quot; header specifies amount of time in seconds required for user agent to wait for making a new request.","ref":"limiters.html#token-bucket","title":"Redis Lua script rate limiters - Token bucket","type":"extras"}]